#ifndef WORLDRENDERER_H
#define WORLDRENDERER_H

#include "client/rendering/Renderer.h"
#include "common/world/World.h"
#include "client/rendering/Mesh.h"
#include "client/rendering/FileTexture.h"
#include "client/rendering/NormalTexture.h"

class WorldRenderer {
public:
    WorldRenderer(const World& world);

    void render(float lag, Renderer& renderer) const;
    void addCube(float x, float y, float z, bool bottom, bool top, bool left, bool right, bool front, bool back);
    bool isAir(uint x, uint y, uint z) const;

private:
    const World& world;
    Mesh mesh;
    FileTexture texture;
    NormalTexture normalTexture;
};

#endif