#ifndef PACKET_H
#define PACKET_H

#include "common/enet/enet.h"

#include "common/utils/Types.h"

class Packet {
public:
    Packet(ENetPacket* packet);
    ~Packet();
    Packet(const Packet&) = delete;
    Packet& operator=(const Packet&) = delete;
    Packet(Packet&&) = delete;
    Packet& operator=(Packet&&) = delete;
    
    bool hasData() const;
    bool hasError() const;
    
    void read(void* buffer, uint length);
    u8 readU8();
    u16 readU16();
    u32 readU32();

private:
    ENetPacket* packet;
    uint readIndex;
    bool error;
};

#endif