#version 430

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 color;

uniform mat4 proj;
uniform mat4 view;
uniform mat4 model;

out vec3 varPosition;
out vec3 varColor;

void main(void) { 
    vec4 worldPos = view * model * vec4(position, 1.0);
    varPosition = worldPos.xyz;
    gl_Position = proj * worldPos;
    varColor = color;
}